<?php
/**
 * @version     1.0.0
 * @package     com_jadmins
 * @copyright   Copyright (C) 2014. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Jadmins <mail@jadmins.com> - http://www.jadmins.com/
 */

// No direct access
defined('_JEXEC') or die;

/**
 * Jadmins helper.
 */
class JadminsHelper
{
	/**
	 * Configure the Linkbar.
	 */
	public static function addSubmenu($vName = '')
	{
		JSubMenuHelper::addEntry(
			JText::_('COM_JADMINS_TITLE_HOMES'),
			'index.php?option=com_jadmins&view=homes',
			$vName == 'homes'
		);
		JSubMenuHelper::addEntry(
			JText::_('COM_JADMINS_TITLE_FOLLOWS'),
			'index.php?option=com_jadmins&view=follows',
			$vName == 'follows'
		);
    JSubMenuHelper::addEntry(
			JText::_('COM_JADMINS_TITLE_CATEGS'),
			'index.php?option=com_jadmins&view=categs',
			$vName == 'categs'
		);
		JSubMenuHelper::addEntry(
			JText::_('COM_JADMINS_TITLE_SEARCHS'),
			'index.php?option=com_jadmins&view=searchs',
			$vName == 'searchs'
		);
    
    JSubMenuHelper::addEntry(
			JText::_('COM_JADMINS_TITLE_POST'),
			'index.php?option=com_jadmins&view=post',
			$vName == 'post'
		);
    JSubMenuHelper::addEntry(
			JText::_('COM_JADMINS_TITLE_HELP'),
			'index.php?option=com_jadmins&view=help',
			$vName == 'help'
		);

	}

	/**
	 * Gets a list of the actions that can be performed.
	 *
	 * @return	JObject
	 * @since	1.6
	 */
	public static function getActions()
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		$assetName = 'com_jadmins';

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.own', 'core.edit.state', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action, $user->authorise($action, $assetName));
		}

		return $result;
	}
}
