<?php
//ini_set("display_errors",1);
//error_reporting(E_ALL);
/**
 * @version     1.0.0
 * @package     com_jadmins
 * @copyright   Copyright (C) 2014. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Jadmins <mail@jadmins.com> - http://www.jadmins.com/
 */


// No direct access
defined('_JEXEC') or die;
if (!defined('JPATH_JADMINS')) {
	define('JPATH_JADMINS', dirname(__FILE__));
}
class jadmin
{
  public $config;
  public $security_key;
  public $security_key2;
  
  function __construct()
  {
    $db = JFactory::getDbo();
    $sql="select * from #__jadmins_sys where id=1";
    $db->setQuery($sql);
    $config=$db->loadObject();
    $this->config=$config;
    require_once JPATH_JADMINS.'/ja_security.php';
    $jas=new jadminsecurity();
    $this->security_key=$jas->getSecurityKey();
    $this->security_key2=$jas->getSecurityKey2();
  }
  function checkDomainName()
  {
    $dn = str_ireplace("www.","",@$_SERVER['HTTP_HOST']);
    if($dn=="" || $dn=='localhost' || $dn=='127.0.0.1')
    {
      $app=JFactory::getApplication();
      $app->enqueueMessage('Please note that Jadmins doesn\'t work on localhost, you need to have your website under a domain name','error');
    }
    $parser = JFactory::getXMLParser('simple');
    $xml = JPATH_JADMINS .'/jadmins.xml';
    
    $parser->loadFile($xml);
    $doc = $parser->document;
    $element = $doc->getElementByPath('version');
    $version = $element->data();
    $new_version=$this->config->latest_version;
    if(version_compare($version,$new_version)=='-1')
    {
      $app=JFactory::getApplication();
      $app->enqueueMessage('Please note that your Jadmins version is not up to date. Please download the latest version from <a target="_blank" href="http://www.jadmins.com/">jadmins.com</a>','notice');
    }
  }
  function refreshSystem()
  {
    $refresh=0;
    $last_refresh=0;
    $new_refresh=0;
    $db=JFactory::getDBO();
    $sql="select refresh_sys from #__jadmins_sys where id=1";
    $db->setQuery($sql);
    $result=$db->loadObject();
    if(isset($result->refresh_sys))
    {
      $last_refresh=$result->refresh_sys+0;
    }
    if($last_refresh==0)
    {
      $refresh=1;
    }
    else
    {
      $new_refresh=$last_refresh+(60*60*24);
    }
    if(time()>=$new_refresh && $refresh==0)
    {
      $refresh=1;
    }
    if($refresh==1)
    {
      $categories_json="";
      $checkurl='http://www.jadmins.com/jact/get_categories.php?a=1';
      $categories_json=$this->doJadminRequest($checkurl);
      $categories=array();
      if($categories_json!="")
      {
        $categories=json_decode($categories_json);
      }
      if(count($categories)>0)
      {
        foreach($categories as $categ)
        {
          $sql="insert into #__jadmins_categories (`cat_id`,`title`,`description`,`published`)
          values 
          ('".$db->getEscaped($categ->id)."',
          '".$db->getEscaped($categ->title)."',
          '".$db->getEscaped($categ->description)."',
          '".$db->getEscaped($categ->published)."') 
          on duplicate key update 
          title='".$db->getEscaped($categ->title)."',
          description='".$db->getEscaped($categ->description)."',
          published='".$db->getEscaped($categ->published)."' 
          ";
          $db->setQuery($sql);
          $db->query();
        }
        //refresh system
        $system_json="";
        $checkurl='http://www.jadmins.com/jact/get_system.php?a=1';
        $system_json=$this->doJadminRequest($checkurl);
        $system=array();
        if($system_json!="")
        {
          $system=json_decode($system_json);
        }
        if(count($system)>0)
        {
          $sys=$system[0];
          $sql="update #__jadmins_sys set
          author_max='".$db->getEscaped($sys->author_max)."',
          joomla_max='".$db->getEscaped($sys->joomla_max)."',
          component_max='".$db->getEscaped($sys->component_max)."',
          title_max='".$db->getEscaped($sys->title_max)."',
          post_max='".$db->getEscaped($sys->post_max)."',
          reply_max='".$db->getEscaped($sys->reply_max)."',
          post_min='".$db->getEscaped($sys->post_min)."',
          intro_max='".$db->getEscaped($sys->intro_max)."',
          request_timeout='".$db->getEscaped($sys->request_timeout)."',
          comp_tos='".$db->getEscaped($sys->comp_tos)."',
          latest_version='".$db->getEscaped($sys->latest_version)."',
          refresh_follow_interval='".$db->getEscaped($sys->refresh_follow_interval)."',
          lines_nr='".$db->getEscaped($sys->lines_nr)."'
          where id=1
          ";
          $db->setQuery($sql);
          $db->query();
        }
        //set time in db
        $sql="update #__jadmins_sys set refresh_sys='".time()."' where id=1";
        $db->setQuery($sql);
        $db->query();
      }
    }
  }
  function getCategs()
  {
    $db=JFactory::getDBO();
    $sql="select * from #__jadmins_categories where published=1 order by title asc";
    $db->setQuery($sql);
    $objects=$db->loadObjectList();
    if(count($objects)>0)
    {
      $temp_objects=array();
      foreach($objects as $obj)
      {
        if($obj->cat_id==43 || $obj->cat_id==44 || $obj->cat_id==45)
        {
          $temp_objects[]=$obj;
        }
      }
      foreach($objects as $obj)
      {
        if($obj->cat_id!='43' && $obj->cat_id!=44 && $obj->cat_id!=45)
        {
          $temp_objects[]=$obj;
        }
      }
      $objects=$temp_objects;
      return $objects;
    }
    return array();
  }
  function getHomeArticlesUpdate($page=0)
  {
    $page+=0;

    $articles_json="";
    $existing_ids=$this->getHomePostsIDs($page);
    //print_r($existing_ids);
    $existing_ids_arr=array();
    $existing_ids_str="";
    foreach($existing_ids as $post)
    {
      $existing_ids_arr[]=$post->post_id;
    }
    $existing_ids_str=implode(",",$existing_ids_arr);
    $checkurl='http://www.jadmins.com/jact/get_home_articles.php?page='.$page."&exist=".$existing_ids_str;
    $articles_json=$this->doJadminRequest($checkurl);
    $articles=array();
    if($articles_json!="")
    {
      $articles=json_decode($articles_json);
    }
    if(count($articles)>0)
    {
      //echo "online";
      $db=JFactory::getDBO();
      $article_ids=array();
      foreach($articles as $post)
      {
        if($post->id=="pag")
          continue;
        $sql="insert into #__jadmins_posts 
        (`post_id`,`cat_id`,`joomla`,`component`,`title`,`content`,`author`,`site`,`mdate`,`published`)
        values 
        ('".$db->getEscaped($post->id)."',
        '".$db->getEscaped($post->catid)."',
        '".$db->getEscaped($post->joomla)."',
        '".$db->getEscaped($post->component)."',
        '".$db->getEscaped($post->title)."',
        '".$db->getEscaped($post->introtext)."',
        '".$db->getEscaped($post->author)."',
        '".$db->getEscaped($post->site)."',
        '".$db->getEscaped($post->created)."',
        '".$db->getEscaped($post->state)."') 
        on duplicate key update 
        published='".$db->getEscaped($post->state)."'
        ";
        $db->setQuery($sql);                    
        $db->query();
        $article_ids[]=$post->id;
      }
      $pagination=$articles[0];//pagination
      $objects=array();
      $articles=array();
      if(count($article_ids)>0)//need to load from local db, because of unpublished articles
      {
        $sql="
        SELECT
        #__jadmins_posts.post_id,
        #__jadmins_posts.cat_id,
        #__jadmins_posts.joomla,
        #__jadmins_posts.component,
        #__jadmins_posts.title,
        #__jadmins_posts.content,
        #__jadmins_posts.author,
        #__jadmins_posts.site,
        #__jadmins_posts.has_update,
        #__jadmins_posts.mdate,
        #__jadmins_categories.title as category
        FROM
        #__jadmins_posts
        INNER JOIN #__jadmins_categories ON #__jadmins_categories.cat_id = #__jadmins_posts.cat_id
        WHERE
        #__jadmins_posts.published = 1 AND
        #__jadmins_categories.published = 1 AND
        #__jadmins_posts.post_id IN (".implode(",",$article_ids).")
        ORDER BY
        #__jadmins_posts.mdate DESC
        ";
        $db->setQuery($sql);
        $objects=$db->loadObjectList();
      }
      $articles['pagination']=$pagination;
      $articles['items']=$objects;
      return $articles;//pagination and articles
    }
    return array();
    
  }
  function getSearchArticlesUpdate($page=0,$filter_search="")
  {
    $page+=0;

    $articles_json="";
    $existing_ids=$this->getSearchPostsIDs($page,$filter_search);
    //print_r($existing_ids);
    $existing_ids_arr=array();
    $existing_ids_str="";
    foreach($existing_ids as $post)
    {
      $existing_ids_arr[]=$post->post_id;
    }
    $existing_ids_str=implode(",",$existing_ids_arr);
    $checkurl='http://www.jadmins.com/jact/get_search_articles.php?page='.$page."&search=".urlencode($filter_search)."&exist=".$existing_ids_str;
    $articles_json=$this->doJadminRequest($checkurl);
    $articles=array();
    if($articles_json!="")
    {
      $articles=json_decode($articles_json);
    }
    //echo $articles_json;
    if(count($articles)>1)
    {
      //echo "online";
      $db=JFactory::getDBO();
      $article_ids=array();
      foreach($articles as $post)
      {
        if($post->id=="pag")
          continue;
        $sql="insert into #__jadmins_posts 
        (`post_id`,`cat_id`,`joomla`,`component`,`title`,`content`,`author`,`site`,`mdate`,`published`)
        values 
        ('".$db->getEscaped($post->id)."',
        '".$db->getEscaped($post->catid)."',
        '".$db->getEscaped($post->joomla)."',
        '".$db->getEscaped($post->component)."',
        '".$db->getEscaped($post->title)."',
        '".$db->getEscaped($post->introtext)."',
        '".$db->getEscaped($post->author)."',
        '".$db->getEscaped($post->site)."',
        '".$db->getEscaped($post->created)."',
        '".$db->getEscaped($post->state)."') 
        on duplicate key update 
        published='".$db->getEscaped($post->state)."'
        ";
        $db->setQuery($sql);                    
        $db->query();
        $article_ids[]=$post->id;
      }
      $pagination=$articles[0];//pagination
      $objects=array();
      $articles=array();
      if(count($article_ids)>0)//need to load from local db, because of unpublished articles
      {
        $sql="
        SELECT
        #__jadmins_posts.post_id,
        #__jadmins_posts.cat_id,
        #__jadmins_posts.joomla,
        #__jadmins_posts.component,
        #__jadmins_posts.title,
        #__jadmins_posts.content,
        #__jadmins_posts.author,
        #__jadmins_posts.site,
        #__jadmins_posts.has_update,
        #__jadmins_posts.mdate,
        #__jadmins_categories.title as category
        FROM
        #__jadmins_posts
        INNER JOIN #__jadmins_categories ON #__jadmins_categories.cat_id = #__jadmins_posts.cat_id
        WHERE
        #__jadmins_posts.published = 1 AND
        #__jadmins_categories.published = 1 AND
        #__jadmins_posts.post_id IN (".implode(",",$article_ids).")
        ORDER BY
        #__jadmins_posts.mdate DESC
        ";
        $db->setQuery($sql);
        $objects=$db->loadObjectList();
      }
      $articles['pagination']=$pagination;
      $articles['items']=$objects;
      return $articles;//pagination and articles
    }
    return array();
    
  }
  function getCategArticlesUpdate($page=0,$categ=0)
  {
    $page+=0;
    $categ+=0;
    if($categ>0)
    {
      $articles_json="";
      $existing_ids=$this->getCategoryPostsIDs($page,$categ);
      $existing_ids_arr=array();
      $existing_ids_str="";
      foreach($existing_ids as $post)
      {
        $existing_ids_arr[]=$post->post_id;
      }
      $existing_ids_str=implode(",",$existing_ids_arr);
      $checkurl='http://www.jadmins.com/jact/get_categ_articles.php?page='.$page."&categ=".$categ."&exist=".$existing_ids_str;
      $articles_json=$this->doJadminRequest($checkurl);
      $articles=array();
      if($articles_json!="")
      {
        $articles=json_decode($articles_json);
      }
      if(count($articles)>1)
      {
        //echo "online";
        $db=JFactory::getDBO();
        $article_ids=array();
        foreach($articles as $post)
        {
          if($post->id=="pag")
            continue;
          $sql="insert into #__jadmins_posts 
          (`post_id`,`cat_id`,`joomla`,`component`,`title`,`content`,`author`,`site`,`mdate`,`published`)
          values 
          ('".$db->getEscaped($post->id)."',
          '".$db->getEscaped($post->catid)."',
          '".$db->getEscaped($post->joomla)."',
          '".$db->getEscaped($post->component)."',
          '".$db->getEscaped($post->title)."',
          '".$db->getEscaped($post->introtext)."',
          '".$db->getEscaped($post->author)."',
          '".$db->getEscaped($post->site)."',
          '".$db->getEscaped($post->created)."',
          '".$db->getEscaped($post->state)."') 
          on duplicate key update 
          published='".$db->getEscaped($post->state)."'
          ";
          $db->setQuery($sql);                    
          $db->query();
          $article_ids[]=$post->id;
        }
        $pagination=$articles[0];//pagination
        $objects=array();
        $articles=array();
        if(count($article_ids)>0)//need to load from local db, because of unpublished articles
        {
          $sql="
          SELECT
          #__jadmins_posts.post_id,
          #__jadmins_posts.joomla,
          #__jadmins_posts.component,
          #__jadmins_posts.title,
          #__jadmins_posts.content,
          #__jadmins_posts.author,
          #__jadmins_posts.site,
          #__jadmins_posts.has_update,
          #__jadmins_posts.mdate,
          #__jadmins_categories.title as category
          FROM
          #__jadmins_posts
          INNER JOIN #__jadmins_categories ON #__jadmins_categories.cat_id = #__jadmins_posts.cat_id
          WHERE
          #__jadmins_posts.published = 1 AND
          #__jadmins_categories.published = 1 AND
          #__jadmins_posts.cat_id=".$categ." AND
          #__jadmins_posts.post_id IN (".implode(",",$article_ids).")
          ORDER BY
          #__jadmins_posts.mdate DESC
          ";
          $db->setQuery($sql);
          $objects=$db->loadObjectList();
        }
        $articles['pagination']=$pagination;
        $articles['items']=$objects;
        return $articles;//pagination and articles
      }
      return array();
    }
    return array();
  }
  function getCategoryPostsIDs($page=0,$categ=0)
  {
    $page+=0;
    $categ+=0;
    $db=JFactory::getDBO();
    $sql="
    SELECT
    #__jadmins_posts.post_id
    FROM
    #__jadmins_posts
    INNER JOIN #__jadmins_categories ON #__jadmins_categories.cat_id = #__jadmins_posts.cat_id
    WHERE
    #__jadmins_posts.published = 1 AND
    #__jadmins_categories.published = 1 AND
    #__jadmins_posts.cat_id=".$categ."
    ORDER BY
    #__jadmins_posts.mdate DESC
    LIMIT ".($page*$this->config->lines_nr).", ".$this->config->lines_nr."
    ";
    $db->setQuery($sql);
    $objects=$db->loadObjectList();
    return $objects;
  }
  function getHomePostsIDs($page=0)
  {
    $page+=0;
    $db=JFactory::getDBO();
    $sql="
    SELECT
    #__jadmins_posts.post_id
    FROM
    #__jadmins_posts
    INNER JOIN #__jadmins_categories ON #__jadmins_categories.cat_id = #__jadmins_posts.cat_id
    WHERE
    #__jadmins_posts.published = 1 AND
    #__jadmins_categories.published = 1 
    ORDER BY
    #__jadmins_posts.mdate DESC
    LIMIT ".($page*$this->config->lines_nr).", ".$this->config->lines_nr."
    ";
    $db->setQuery($sql);
    $objects=$db->loadObjectList();
    return $objects;
  }
  function getSearchPostsIDs($page=0,$filter_search="")
  {
    $page+=0;
    $db=JFactory::getDBO();
    $sql="
    SELECT
    #__jadmins_posts.post_id
    FROM
    #__jadmins_posts
    INNER JOIN #__jadmins_categories ON #__jadmins_categories.cat_id = #__jadmins_posts.cat_id
    WHERE
    #__jadmins_posts.published = 1 AND
    #__jadmins_categories.published = 1  AND
    (#__jadmins_posts.title like '%".$db->getEscaped($filter_search)."%' OR
    #__jadmins_posts.content like '%".$db->getEscaped($filter_search)."%')
    ORDER BY
    #__jadmins_posts.mdate DESC
    LIMIT ".($page*$this->config->lines_nr).", ".$this->config->lines_nr."
    ";
    $db->setQuery($sql);
    $objects=$db->loadObjectList();
    return $objects;
  }
  function getPostReplyIDs($post_id=0,$page=0)
  {
    if($post_id>0)
    {
      $page+=0;
      $db=JFactory::getDBO();
      $sql="
      SELECT
      #__jadmins_reply.reply_id
      FROM
      #__jadmins_reply
      INNER JOIN #__jadmins_posts ON #__jadmins_posts.post_id = #__jadmins_reply.post_id
      INNER JOIN #__jadmins_categories ON #__jadmins_categories.cat_id = #__jadmins_posts.cat_id
      WHERE
      #__jadmins_reply.post_id='".$db->getEscaped($post_id)."' and
      #__jadmins_reply.published = 1 AND
      #__jadmins_posts.published = 1 AND
      #__jadmins_categories.published = 1 
      ORDER BY
      #__jadmins_posts.mdate DESC
      LIMIT ".($page*$this->config->lines_nr).", ".$this->config->lines_nr."
      ";
      $db->setQuery($sql);
      $objects=$db->loadObjectList();
      return $objects;
    }
    return array();
  }
  /*
  get category posts by page and categ id, only published
  */
  function getCategoryPosts($page=0,$categ=0)
  {
    $page+=0;
    $categ+=0;
    $db=JFactory::getDBO();
    $sql="
    SELECT
    #__jadmins_posts.post_id,
    #__jadmins_posts.joomla,
    #__jadmins_posts.component,
    #__jadmins_posts.title,
    #__jadmins_posts.content,
    #__jadmins_posts.author,
    #__jadmins_posts.site,
    #__jadmins_posts.has_update,
    #__jadmins_posts.mdate,
    #__jadmins_categories.title as category
    FROM
    #__jadmins_posts
    INNER JOIN #__jadmins_categories ON #__jadmins_categories.cat_id = #__jadmins_posts.cat_id
    WHERE
    #__jadmins_posts.published = 1 AND
    #__jadmins_categories.published = 1 AND
    #__jadmins_posts.cat_id=".$categ."
    ORDER BY
    #__jadmins_posts.mdate DESC
    LIMIT ".($page*$this->config->lines_nr).", ".$this->config->lines_nr."
    ";
    $db->setQuery($sql);
    $objects=$db->loadObjectList();
    return $objects;
  }
  function getArticleReply($page=0,$post_id=0)
  {
    $page+=0;
    $post_id+=0;
    $db=JFactory::getDBO();
    $sql="
    SELECT
    #__jadmins_reply.reply_id,
    #__jadmins_reply.post_id,
    #__jadmins_reply.reply,
    #__jadmins_reply.author,
    #__jadmins_reply.site,
    #__jadmins_reply.mdate,
    #__jadmins_reply.reported
    FROM
    #__jadmins_reply
    INNER JOIN #__jadmins_posts ON #__jadmins_posts.post_id = #__jadmins_reply.post_id
    INNER JOIN #__jadmins_categories ON #__jadmins_categories.cat_id = #__jadmins_posts.cat_id
    WHERE
    #__jadmins_reply.post_id='".$post_id."' AND
    #__jadmins_reply.published=1 AND
    #__jadmins_posts.published = 1 AND
    #__jadmins_categories.published = 1
    ORDER BY
    #__jadmins_reply.mdate DESC
    LIMIT ".($page*$this->config->lines_nr).", ".$this->config->lines_nr."
    ";
    $db->setQuery($sql);
    $objects=$db->loadObjectList();
    return $objects;
  }
  function getHomePosts($page=0)
  {
    $page+=0;
    $db=JFactory::getDBO();
    $sql="
    SELECT
    #__jadmins_posts.post_id,
    #__jadmins_posts.cat_id,
    #__jadmins_posts.joomla,
    #__jadmins_posts.component,
    #__jadmins_posts.title,
    #__jadmins_posts.content,
    #__jadmins_posts.author,
    #__jadmins_posts.site,
    #__jadmins_posts.has_update,
    #__jadmins_posts.mdate,
    #__jadmins_categories.title as category
    FROM
    #__jadmins_posts
    INNER JOIN #__jadmins_categories ON #__jadmins_categories.cat_id = #__jadmins_posts.cat_id
    WHERE
    #__jadmins_posts.published = 1 AND
    #__jadmins_categories.published = 1 
    ORDER BY
    #__jadmins_posts.mdate DESC
    LIMIT ".($page*$this->config->lines_nr).", ".$this->config->lines_nr."
    ";
    $db->setQuery($sql);
    $objects=$db->loadObjectList();
    return $objects;
  }
  function getSearchPosts($page=0,$filter_search="")
  {
    $page+=0;
    $filter_search=htmlspecialchars($filter_search);
    $db=JFactory::getDBO();
    $sql="
    SELECT
    #__jadmins_posts.post_id,
    #__jadmins_posts.cat_id,
    #__jadmins_posts.joomla,
    #__jadmins_posts.component,
    #__jadmins_posts.title,
    #__jadmins_posts.content,
    #__jadmins_posts.author,
    #__jadmins_posts.site,
    #__jadmins_posts.has_update,
    #__jadmins_posts.mdate,
    #__jadmins_categories.title as category
    FROM
    #__jadmins_posts
    INNER JOIN #__jadmins_categories ON #__jadmins_categories.cat_id = #__jadmins_posts.cat_id
    WHERE
    #__jadmins_posts.published = 1 AND
    #__jadmins_categories.published = 1  AND
    (#__jadmins_posts.title like '%".$db->getEscaped($filter_search)."%' OR
    #__jadmins_posts.content like '%".$db->getEscaped($filter_search)."%')
    ORDER BY
    #__jadmins_posts.mdate DESC
    LIMIT ".($page*$this->config->lines_nr).", ".$this->config->lines_nr."
    ";
    $db->setQuery($sql);
    $objects=$db->loadObjectList();
    return $objects;
  }
  /*
  get category article nr, only published
  */
  public function getCategArticleNr($categ)
  {
    $categ+=0;
    $db = JFactory::getDbo();
    $sql="
    SELECT
    count(*) as total
    FROM
    #__jadmins_posts
    inner join #__jadmins_categories on #__jadmins_categories.cat_id=#__jadmins_posts.cat_id
    WHERE #__jadmins_posts.cat_id='".$categ."' and 
    #__jadmins_categories.published=1 and
    #__jadmins_posts.published=1
    ";
    $db->setQuery($sql);
    $option=$db->loadObject();
    if(isset($option->total))
    {
      return ($option->total+0);
    }
    return 0;
  }
  public function getArticleReplyNr($post_id)
  {
    $post_id+=0;
    if($post_id==0)
      return 0;
    $db = JFactory::getDbo();
    $sql="
    SELECT
    count(*) as total
    FROM
    #__jadmins_reply
    inner join #__jadmins_posts on #__jadmins_posts.post_id=#__jadmins_reply.post_id
    inner join #__jadmins_categories on #__jadmins_categories.cat_id=#__jadmins_posts.cat_id
    WHERE 
    #__jadmins_reply.post_id='".$post_id."' and
    #__jadmins_posts.published='1' and 
    #__jadmins_categories.published=1
    ";
    $db->setQuery($sql);
    $option=$db->loadObject();
    if(isset($option->total))
    {
      return ($option->total+0);
    }
    return 0;
  }
  public function getHomeArticleNr()
  {
    $db = JFactory::getDbo();
    $sql="
    SELECT
    count(*) as total
    FROM
    #__jadmins_posts
    inner join #__jadmins_categories on #__jadmins_categories.cat_id=#__jadmins_posts.cat_id
    WHERE 
    #__jadmins_categories.published=1 and
    #__jadmins_posts.published=1
    ";
    $db->setQuery($sql);
    $option=$db->loadObject();
    if(isset($option->total))
    {
      return ($option->total+0);
    }
    return 0;
  }
  public function getSearchArticleNr($filter_search="")
  {
    $db = JFactory::getDbo();
    $sql="
    SELECT
    count(*) as total
    FROM
    #__jadmins_posts
    inner join #__jadmins_categories on #__jadmins_categories.cat_id=#__jadmins_posts.cat_id
    WHERE 
    #__jadmins_categories.published=1 and
    #__jadmins_posts.published=1 AND
    (#__jadmins_posts.title like '%".$db->getEscaped($filter_search)."%' OR
    #__jadmins_posts.content like '%".$db->getEscaped($filter_search)."%')
    ";
    $db->setQuery($sql);
    $option=$db->loadObject();
    if(isset($option->total))
    {
      return ($option->total+0);
    }
    return 0;
  }
  /*
  get category name or default category text
  */
  function getCategoryName($categ)
  {
    $categ+=0;
    if($categ>0)
    {
      $db=JFactory::getDBO();
      $sql="select title from #__jadmins_categories where cat_id='".$categ."'";
      $db->setQuery($sql);
      $object=$db->loadObject();
      return $object->title;
    }
    else
    {
      return JText::_('COM_JADMINS_TITLE_CATEGORYS');
    }
    return JText::_('COM_JADMINS_TITLE_CATEGORYS');
  }
  function getArticle($post_id)
  {
    $post_id+=0;
    if($post_id>0)
    {
      $db=JFactory::getDBO();
      $sql="select 
      #__jadmins_posts.*, 
      #__jadmins_categories.title as category,
      #__jadmins_follow.post_id as follow
      from 
      #__jadmins_posts 
      inner join #__jadmins_categories on #__jadmins_categories.cat_id=#__jadmins_posts.cat_id
      left join #__jadmins_follow on #__jadmins_follow.post_id=#__jadmins_posts.post_id
      where 
      #__jadmins_posts.post_id='".$post_id."' and 
      #__jadmins_posts.published=1 and 
      #__jadmins_categories.published=1";
      $db->setQuery($sql);
      $object=$db->loadObject();
      if(isset($object->post_id))
      {
        $sql="update #__jadmins_posts set has_update=0 where post_id='".$object->post_id."' limit 1";
        $db->setQuery($sql);
        $db->query();
      }
      $object->content_raw=$object->content;
      $object->content=$this->makeClickableLinks($object->content);
      //$object->content=str_replace(" ","&nbsp;",$object->content);
      $object->content=nl2br($object->content);
      //$object->content='<pre>'.$object->content.'</pre>';
      return $object;
    }
    return array();
  }
  function getArticleReplyUpdates($page=0,$post_id=0)
  {
    $post_id+=0;
    $page+=0;
    if($post_id>0)
    {
      $db=JFactory::getDBO();
      $reply_json="";
      $existing_ids=$this->getPostReplyIDs($page);
      //print_r($existing_ids);
      $existing_ids_arr=array();
      $existing_ids_str="";
      foreach($existing_ids as $post)
      {
        $existing_ids_arr[]=$post->reply_id;
      }
      $existing_ids_str=implode(",",$existing_ids_arr);
      
      $checkurl='http://www.jadmins.com/jact/get_reply.php?page='.$page."&post_id=".$post_id."&exist=".$existing_ids_str;
      $reply_json=$this->doJadminRequest($checkurl);
      $reply=array();
      if($reply_json!="")
      {
        $reply=json_decode($reply_json);
      }
      if(count($reply)>1)
      {
        //echo "online";
        $db=JFactory::getDBO();
        $reply_ids=array();
        foreach($reply as $post)
        {
          if($post->id=="pag")
            continue;
          $sql="insert into #__jadmins_reply 
          (`post_id`,`reply_id`,`reply`,`author`,`site`,`mdate`,`published`)
          values 
          ('".$db->getEscaped($post->post_id)."',
          '".$db->getEscaped($post->id)."',
          '".$db->getEscaped($post->reply)."',
          '".$db->getEscaped($post->author)."',
          '".$db->getEscaped($post->site)."',
          '".$db->getEscaped($post->mdate)."',
          '".$db->getEscaped($post->published)."') 
          on duplicate key update 
          published='".$db->getEscaped($post->published)."'
          ";
          $db->setQuery($sql);                    
          $db->query();
          $reply_ids[]=$post->id;
        }
        $pagination=$reply[0];//pagination
        $objects=array();
        $reply=array();
        if(count($reply_ids)>0)//need to load from local db, because of unpublished articles
        {
          $sql="
          SELECT
          #__jadmins_reply.post_id,
          #__jadmins_reply.reply_id,
          #__jadmins_reply.reply,
          #__jadmins_reply.author,
          #__jadmins_reply.site,
          #__jadmins_reply.mdate,
          #__jadmins_reply.reported
          FROM
          #__jadmins_reply
          WHERE
          #__jadmins_reply.published = 1 AND
          #__jadmins_reply.reply_id IN (".implode(",",$reply_ids).")
          ORDER BY
          #__jadmins_reply.mdate DESC
          ";
          $db->setQuery($sql);
          
          $objects=$db->loadObjectList();
        }
        $reply['pagination']=$pagination;
        $reply['items']=$objects;
        return $reply;//pagination and articles
      }
      return array();
    }
    return array();
  }
  function makeClickableLinks($s)
  {
    return preg_replace('@(https?://([-\w\.]+[-\w])+(:\d+)?(/([\w/_\.#-]*(\?\S+)?[^\.\s])?)?)@', '<a href="$1" target="_blank">$1</a>', $s);
  }
  function submitNewPost()
  {
    $categ=isset($_POST['categ'])?$_POST['categ']+0:"";
    $author=isset($_POST['author'])?$_POST['author']:"";
    $site=isset($_POST['site'])?$_POST['site']+0:"";
    $joomla=isset($_POST['joomla'])?$_POST['joomla']:"";
    $component=isset($_POST['component'])?$_POST['component']:"";
    $title=isset($_POST['title'])?$_POST['title']:"";
    $post=isset($_POST['post'])?$_POST['post']:"";
    
    jimport( 'joomla.filter.filterinput' );
    $filter=JFilterInput::getInstance();
    
    $author=$filter->clean($author);
    //$post=$filter->clean($post);
    $joomla=$filter->clean($joomla);
    $component=$filter->clean($component);
    $title=$filter->clean($title);
    
    $author=substr($author,0,$this->config->author_max+1);
    $post=substr($post,0,$this->config->post_max+1);
    $joomla=substr($joomla,0,$this->config->joomla_max+1);
    $component=substr($component,0,$this->config->component_max+1);
    $title=substr($title,0,$this->config->title_max+1);
    $post=str_replace("&",urlencode("&"),$post);
    $checkurl = "http://www.jadmins.com/jact/new_post.php?a=1";
    $post_fields = "key2=".$this->security_key2."&categ=$categ&site=$site&author=$author&post=$post&joomla=$joomla&component=$component&title=$title";
    
    $curl_result = $this->doJadminPostRequest($checkurl,$post_fields);
    
    $application = JFactory::getApplication();
    
    if($curl_result!="")
    {
      $result=json_decode($curl_result);
      
      if(isset($result->ok) && $result->ok==1)
      {
        $msg=(isset($result->msg))?$result->msg:"New post added with success";
        $application->enqueueMessage($msg);
        $new_id=$result->id;
        if($new_id>0)
        {
          $db=Jfactory::getDbo();
          $sql="insert into #__jadmins_follow set post_id='".$db->getEscaped($new_id)."'";
          $db->setQuery($sql);
          $db->query();
        }
        $application->redirect(juri::base()."index.php?option=com_jadmins&view=homes");
        return;
      }
      else
      {
        $msg=(isset($result->msg))?$result->msg:"Something went wrong please try again later";
        $application->enqueueMessage($msg,'error');
        $application->redirect(juri::base()."index.php?option=com_jadmins&view=homes");
        return;
      }
    }
    return;
  }
  function submitNewReply()
  {
    $post_id=isset($_GET['id'])?$_GET['id']+0:0;
    $author=isset($_POST['author'])?$_POST['author']:"";
    $site=isset($_POST['site'])?$_POST['site']+0:"";
    $reply=isset($_POST['reply'])?$_POST['reply']:"";
    
    jimport( 'joomla.filter.filterinput' );
    $filter=JFilterInput::getInstance();

    $author=$filter->clean($author);
    //$reply=$filter->clean($reply);

    $author=substr($author,0,$this->config->author_max+1);
    $reply=substr($reply,0,$this->config->post_max+1);
    $reply=str_replace("&",urlencode("&"),$reply);
    $checkurl = "http://www.jadmins.com/jact/new_reply.php?a=1";
    $post_fields = "key2=".$this->security_key2."&post_id=$post_id&site=$site&author=$author&reply=$reply";
    
    $curl_result = $this->doJadminPostRequest($checkurl,$post_fields);

    $application = JFactory::getApplication();
    
    if($curl_result!="")
    {
      $result=json_decode($curl_result);
      
      if(isset($result->ok) && $result->ok==1)
      {
        $msg=(isset($result->msg))?$result->msg:"New reply added with success";
        $application->enqueueMessage($msg);
        $db=Jfactory::getDbo();
        $sql="select post_id from #__jadmins_follow where post_id='".$post_id."' limit 1";
        $db->setQuery($sql);
        $obj=$db->loadObject();
        if(isset($obj->post_id) && $obj->post_id>0)
        {
          //don't add in following
        }
        else
        {
          $sql="insert into #__jadmins_follow set post_id='".$db->getEscaped($post_id)."'";
          $db->setQuery($sql);
          $db->query();
        }
        
        $application->redirect(juri::base()."index.php?option=com_jadmins&view=posts&id=".$post_id);
      }
      else
      {
        $msg=(isset($result->msg))?$result->msg:"Something went wrong please try again later";
        $application->enqueueMessage($msg,'error');
      }
      return;
    }
    $msg="Something went wrong please try again later";
    $application->enqueueMessage($msg,'error');
    return;
  }
  function doJadminPostRequest($checkurl="",$post_fields="")
  {
    $result="";
    if($checkurl!="" && $post_fields!="")
    {
      $checkurl.="&key=".$this->security_key;
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_URL, $checkurl);
      curl_setopt($ch, CURLOPT_POST, 1);
      curl_setopt($ch, CURLOPT_POSTFIELDS, $post_fields);
      curl_setopt($ch, CURLOPT_TIMEOUT, $this->config->request_timeout);
      curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
      $curl_errno = curl_errno($ch);
      $curl_error = curl_error($ch);
      $result = curl_exec($ch);
      curl_close($ch);
      if ($curl_errno > 0)
      {
        $result = "";
      }
    }
    if($result=="")
    {
      $application = JFactory::getApplication();
      $application->enqueueMessage('Please note that requests to jadmins.com timed out, file_get_contents, cURL disabled or jadmins.com is down ', 'warning');
    }
    return $result;
  }
  function doJadminRequest($checkurl="")
  {
    if($checkurl!="")
    {
      $checkurl.="&key=".$this->security_key;
      $response="";
      if(function_exists('file_get_contents') && $response=="")
      {
        $Context = stream_context_create(array(
        'http' => array(
            'method' => 'GET',
            'timeout' => $this->config->request_timeout,
        )
        ));
        $output=@file_get_contents($checkurl, false, $Context);
        
        if($output===false)
        {
          $response = "";
        }
        else
        {
          $response = $output;
        }
      }
      
      if (function_exists('curl_init') && $response=="")
      {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $checkurl);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_TIMEOUT, $this->config->request_timeout);
        $output = curl_exec($ch);
        $curl_errno = curl_errno($ch);
        $curl_error = curl_error($ch);
        curl_close($ch);
        if ($curl_errno > 0)
        {
          $response = "";
        }
        else
        {
          $response = $output;
        }
      }
      if($response=="")
      {
        $application = JFactory::getApplication();
        $application->enqueueMessage('Please note that requests to jadmins.com timed out, file_get_contents, cURL disabled or jadmins.com is down ', 'warning');
      }
      return $response;
    }
    return "";
  }
  function createPaginationHTML($categ,$pagination,$total_on_page,$view)
  {
    $page=$pagination->page;
    $total=$pagination->total;
    $on_page=$total_on_page;
    $total_pages=ceil($total/$this->config->lines_nr);
    $prev_page=$page-1;
    $prev_page--;
    $next_page=$page;
    $end_page=$total_pages-1;
    
    $html="";
    
    $start_off="";
    $prev_off="";
    $start_link='<a href="'.juri::base()."index.php?option=com_jadmins&view=".$view."&page=0&categ=".$categ.'" title="Start">Start</a>';
    $prev_link='<a href="'.juri::base()."index.php?option=com_jadmins&view=".$view."&page=".$prev_page."&categ=".$categ.'" title="Prev">Prev</a>';
    if($page==1)
    {
      $start_off="off";
      $start_link="<span>Start</span>";
      $prev_off="off";
      $prev_link="<span>Prev</span>";
    }
    
    $next_off="";
    $end_off="";
    $next_link='<a href="'.juri::base()."index.php?option=com_jadmins&view=".$view."&page=".$next_page."&categ=".$categ.'" title="Next">Next</a>';
    $end_link='<a href="'.juri::base()."index.php?option=com_jadmins&view=".$view."&page=".$end_page."&categ=".$categ.'" title="End">End</a>';
    if($page==$total_pages)
    {
      $next_off="off";
      $end_off="off";
      $next_link="<span>Next</span>";
      $end_link="<span>End</span>";
    }
    $page_nrs=$this->getPageNrHTML($page,$end_page,$view,$categ);
    $html = '
    <div class="container">
      <div class="pagination">
        <div class="button2-right '.$start_off.'">
          <div class="start">
            '.$start_link.'
          </div>
        </div>
        <div class="button2-right '.$prev_off.'">
          <div class="prev">
            '.$prev_link.'
          </div>
        </div>
        
        <div class="button2-left">
          <div class="page">
            '.$page_nrs.'
          </div>
        </div>
        
        <div class="button2-left '.$next_off.'">
          <div class="next">
            '.$next_link.'
          </div>
        </div>
        <div class="button2-left '.$end_off.'">
          <div class="end">
            '.$end_link.'
          </div>
        </div>
        <div class="limit">Page '.$page.' of '.$total_pages.'</div>
      </div>
    </div>
    ';
    return $html;
  }
  function getPageNrHTML($page,$total,$view,$categ)
  {
    $html="";
    $total++;
    
    $left=$page-3;
    $right=$page+3;
    
    $left_arr=array();
    $right_arr=array();
    
    $right_extra=0;
    
    for($i=$page-1;$i>=$left;$i--)
    {
      if($i>=1)
      {
        $left_arr[]=$i;
      }
      else
      {
        $right_extra++;
      }
    }
    $left_arr=array_reverse($left_arr);
    for($i=$page+1;$i<=$right;$i++)
    {
      $right_arr[]=$i;
    }
    if($right_extra>0)
    {
      $end_pg=$right_arr[count($right_arr)-1]+$right_extra;
      for($i=$right_arr[count($right_arr)-1]+1;$i<=$end_pg;$i++)
      {
        $right_arr[]=$i;
      }
    }
    
    foreach($left_arr as $l)
    {
      $html.='<a href="'.juri::base()."index.php?option=com_jadmins&view=".$view."&page=".($l-1)."&categ=".$categ.'" title="'.$l.'">'.$l.'</a>';
    }
    $html.='<span>'.$page.'</span>';
    
    foreach($right_arr as $r)
    {
      if($r<=$total)
        $html.='<a href="'.juri::base()."index.php?option=com_jadmins&view=".$view."&page=".($r-1)."&categ=".$categ.'" title="'.$r.'">'.$r.'</a>';
    }
    
    return $html;
  }
  function followPost()
  {
    $db=JFactory::getDBO();
    $post_id=isset($_GET['id'])?$_GET['id']+0:0;
    if($post_id>0)
    {
      $sql="delete from #__jadmins_follow where post_id='".$post_id."'";
      $db->setQuery($sql);
      $db->query();
      $sql="insert into #__jadmins_follow set post_id='".$post_id."'";
      $db->setQuery($sql);
      $db->query();
    }
  }
  function unfollowPost()
  {
    $db=JFactory::getDBO();
    $post_id=isset($_GET['id'])?$_GET['id']+0:0;
    if($post_id>0)
    {
      $sql="delete from #__jadmins_follow where post_id='".$post_id."'";
      $db->setQuery($sql);
      $db->query();
    }
  }
  function reportPost()
  {
    $db=JFactory::getDBO();
    $post_id=isset($_GET['id'])?$_GET['id']+0:0;
    if($post_id>0)
    {
      
      //send report to jadmins.com
      $checkurl='http://www.jadmins.com/jact/report_post.php?post_id='.$post_id;
      $report=$this->doJadminRequest($checkurl);
      $report_arr=array();
      if($report!="")
      {
        $report_arr=json_decode($report);
      }
      $application = JFactory::getApplication();
      if(count($report_arr)>0)
      {
        $sql="update #__jadmins_posts set reported=1 where post_id='".$post_id."'";
        $db->setQuery($sql);
        $db->query();
        if(isset($report_arr->redirect) && $report_arr->redirect==1)
        {
          $sql="delete from #__jadmins_follow where post_id='".$post_id."' limit 1";
          $db->setQuery($sql);
          $db->query();
          $application->enqueueMessage('Entry successfully reported.');
        }
        else
        {
          $application->enqueueMessage('Entry successfully reported. After a number of unique reports this entry will be unpublished');
        }
      }
      else
      {
        $application->enqueueMessage('Error in sending report request. Please try again later.','error');
      }
    }
  }
  function reportReply($reply_id=0)
  {
    $reply_id+=0;
    if($reply_id>0)
    {
      $db=JFactory::getDBO();
      
      //send report to jadmins.com
      $checkurl='http://www.jadmins.com/jact/report_reply.php?reply_id='.$reply_id;
      $report=$this->doJadminRequest($checkurl);
      $application = JFactory::getApplication();
      if($report=="ok")
      {
        $sql="update #__jadmins_reply set reported=1 where reply_id='".$reply_id."' limit 1";
        $db->setQuery($sql);
        $db->query();
        $application->enqueueMessage('Entry successfully reported. After a number of unique reports this entry will be unpublished');
      }
      else
      {
        $application->enqueueMessage('Error in sending report request. Please try again later.','error');
      }
    }
  }
  function unfollowById($unfollow_post_id)
  {
    $db=JFactory::getDBO();
    if($unfollow_post_id>0)
    {
      $sql="delete from #__jadmins_follow where post_id='".$unfollow_post_id."'";
      $db->setQuery($sql);
      $db->query();
    }
  }
  function getPreviewPostHTML($content)
  {
    $new_content=$this->makeClickableLinks($content);
    //$new_content=str_replace(" ","&nbsp;",$new_content);
    
    return nl2br($new_content);
  }
  /*
  get ids for the current page, check if unpublished, load from local
  */
  function getFollowingArticlesUpdates($page=0)
  {
    $page+=0;
    $db=JFactory::getDBO();
    $sql="select 
    #__jadmins_posts.post_id
    from #__jadmins_follow
    inner join #__jadmins_posts on #__jadmins_posts.post_id=#__jadmins_follow.post_id
    inner join #__jadmins_categories on #__jadmins_categories.cat_id=#__jadmins_posts.cat_id
    where
    #__jadmins_posts.published=1 and
    #__jadmins_categories.published=1
    order by #__jadmins_posts.mdate desc
    limit ".($page*$this->config->lines_nr).",".$this->config->lines_nr."
    ";
    $db->setQuery($sql);
    $existing_ids=$db->loadObjectList();
    
    $existing_ids_arr=array();
    $existing_ids_str="";
    foreach($existing_ids as $post)
    {
      $existing_ids_arr[]=$post->post_id;
    }
    $articles_json="";
    if(count($existing_ids_arr)>0)
    {
      $existing_ids_str=implode(",",$existing_ids_arr);
      $checkurl='http://www.jadmins.com/jact/get_follow_articles.php?exist='.$existing_ids_str;
      $articles_json=$this->doJadminRequest($checkurl);
    }
    $articles=array();
    if($articles_json!="")
    {
      $articles=json_decode($articles_json);
    }
    if(count($articles)>0)
    {
      foreach($articles as $post)
      {
        $sql="update #__jadmins_posts set published='".$db->getEscaped($post->state)."' where post_id='".$db->getEscaped($post->id)."'";
        $db->setQuery($sql);
        $db->query();
      }
    }
    return $this->getFollowingArticles($page);
  }
  function getNotifications()
  {
    $db=JFactory::getDBO();
    $sql="select 
    DISTINCT(#__jadmins_posts.post_id),
    (
    select 
    #__jadmins_reply.reply_id 
    from #__jadmins_reply 
    where #__jadmins_reply.post_id=#__jadmins_posts.post_id 
    order by #__jadmins_reply.reply_id desc limit 1
    ) as last_id
    from #__jadmins_follow
    inner join #__jadmins_posts on #__jadmins_posts.post_id=#__jadmins_follow.post_id
    inner join #__jadmins_categories on #__jadmins_categories.cat_id=#__jadmins_posts.cat_id
    left join #__jadmins_reply on #__jadmins_reply.post_id=#__jadmins_posts.post_id
    where
    #__jadmins_posts.published=1 and
    #__jadmins_categories.published=1
    order by #__jadmins_posts.mdate desc
    limit 100
    ";
    $db->setQuery($sql);
    $options=$db->loadObjectList();
    if(count($options)>0)
    {
      $post_ids=array();
      $last_ids=array();
      foreach($options as $post)
      {
        $post_ids[]=$post->post_id;
        $last_ids[]=$post->last_id;
      }
      $post_ids_str=implode(",",$post_ids);
      $last_ids_str=implode(",",$last_ids);
      
      $checkurl='http://www.jadmins.com/jact/get_follow_notification.php?post_id='.$post_ids_str."&last_id=".$last_ids_str;
      $articles_json=$this->doJadminRequest($checkurl);
      $replies=array();
      if($articles_json!="")
      {
        $replies=json_decode($articles_json);
      }
      $updates_arr=array();
      if(count($replies)>0)
      {
        $post_ids=array();
        //print_r($replies);
        foreach($replies as $post_replies)
        {
          foreach($post_replies as $post)
          {
            $sql="insert into #__jadmins_reply 
            (`post_id`,`reply_id`,`reply`,`author`,`site`,`mdate`,`published`)
            values 
            ('".$db->getEscaped($post->post_id)."',
            '".$db->getEscaped($post->id)."',
            '".$db->getEscaped($post->reply)."',
            '".$db->getEscaped($post->author)."',
            '".$db->getEscaped($post->site)."',
            '".$db->getEscaped($post->mdate)."',
            '".$db->getEscaped($post->published)."') 
            on duplicate key update 
            published='".$db->getEscaped($post->published)."'
            ";
            $db->setQuery($sql);                    
            $db->query();
            $post_ids[]=$post->post_id;
          }
        }
        return $this->getNotificationEmailBody($replies,$post_ids);
      }
    }
    return "";
  }
  function getNotificationEmailBody($replies=array(),$post_ids=array())
  {
    if(count($replies)>0 && count($post_ids)>0)
    {
      $body="";
      $db=JFactory::getDBO();
      $sql="select post_id, title from #__jadmins_posts where post_id in (".implode(",",$post_ids).")";
      $db->setQuery($sql);
      $options=$db->loadObjectList();
      if(count($options)>0)
      {
        foreach($options as $opt)
        {
          foreach($replies as $post_replies)
          {
            foreach($post_replies as $reply)
            {
              if($reply->post_id==$opt->post_id)
              {
                $title='<a href="'.str_ireplace("administrator/","",juri::base()).'administrator/index.php?option=com_jadmins&view=posts&id='.$opt->post_id.'">'.$opt->title.'</a>';
                $intro=htmlspecialchars_decode($reply->reply);
                $response=htmlspecialchars(substr($intro,0,$this->config->intro_max+1)."...");
                $body.="$title<br />
                $response<br />
                ";
              }
            }
          }
        }
        return $body;
      }
    }
    return "";
  }
  function getFollowingArticlesUpdatesBySearch($page=0,$filter_search="")
  {
    $page+=0;
    $db=JFactory::getDBO();
    $sql="select 
    #__jadmins_posts.post_id
    from #__jadmins_follow
    inner join #__jadmins_posts on #__jadmins_posts.post_id=#__jadmins_follow.post_id
    inner join #__jadmins_categories on #__jadmins_categories.cat_id=#__jadmins_posts.cat_id
    where
    #__jadmins_posts.published=1 and
    #__jadmins_categories.published=1 AND
    (#__jadmins_posts.title like '%".$db->getEscaped($filter_search)."%' OR
    #__jadmins_posts.content like '%".$db->getEscaped($filter_search)."%')
    order by #__jadmins_posts.mdate desc
    limit ".($page*$this->config->lines_nr).",".$this->config->lines_nr."
    ";
    $db->setQuery($sql);
    
    $existing_ids=$db->loadObjectList();
    
    $existing_ids_arr=array();
    $existing_ids_str="";
    foreach($existing_ids as $post)
    {
      $existing_ids_arr[]=$post->post_id;
    }
    $articles_json="";
    if(count($existing_ids_arr)>0)
    {
      $existing_ids_str=implode(",",$existing_ids_arr);
      $checkurl='http://www.jadmins.com/jact/get_follow_articles.php?exist='.$existing_ids_str;
      $articles_json=$this->doJadminRequest($checkurl);
    }
    $articles=array();
    if($articles_json!="")
    {
      $articles=json_decode($articles_json);
    }
    if(count($articles)>0)
    {
      foreach($articles as $post)
      {
        $sql="update #__jadmins_posts set published='".$db->getEscaped($post->state)."' where post_id='".$db->getEscaped($post->id)."'";
        $db->setQuery($sql);
        $db->query();
      }
    }
    return $this->getFollowingArticlesSearch($page,$filter_search);
  }
  function getFollowingArticles($page=0)
  {
    $page+=0;
    $db=JFactory::getDBO();
    $sql="select 
    #__jadmins_follow.id as fid,
    #__jadmins_posts.*,
    #__jadmins_categories.title as category
    from #__jadmins_follow
    inner join #__jadmins_posts on #__jadmins_posts.post_id=#__jadmins_follow.post_id
    inner join #__jadmins_categories on #__jadmins_categories.cat_id=#__jadmins_posts.cat_id
    where
    #__jadmins_posts.published=1 and
    #__jadmins_categories.published=1
    order by #__jadmins_posts.mdate desc
    limit ".($page*$this->config->lines_nr).",".$this->config->lines_nr."
    ";
    $db->setQuery($sql);
    $options=$db->loadObjectList();
    return $options;
  }
  function getFollowingArticlesSearch($page=0,$filter_search="")
  {
    $page+=0;
    $db=JFactory::getDBO();
    $sql="select 
    #__jadmins_follow.id as fid,
    #__jadmins_posts.*,
    #__jadmins_categories.title as category
    from #__jadmins_follow
    inner join #__jadmins_posts on #__jadmins_posts.post_id=#__jadmins_follow.post_id
    inner join #__jadmins_categories on #__jadmins_categories.cat_id=#__jadmins_posts.cat_id
    where
    #__jadmins_posts.published=1 and
    #__jadmins_categories.published=1 AND
    (#__jadmins_posts.title like '%".$db->getEscaped($filter_search)."%' OR
    #__jadmins_posts.content like '%".$db->getEscaped($filter_search)."%')
    order by #__jadmins_posts.mdate desc
    limit ".($page*$this->config->lines_nr).",".$this->config->lines_nr."
    ";
    $db->setQuery($sql);
    $options=$db->loadObjectList();
    return $options;
  }
  function getFollowingArticlesTotal()
  {
    $db=JFactory::getDBO();
    $sql="select 
    count(*) as total
    from #__jadmins_follow
    inner join #__jadmins_posts on #__jadmins_posts.post_id=#__jadmins_follow.post_id
    inner join #__jadmins_categories on #__jadmins_categories.cat_id=#__jadmins_posts.cat_id
    where
    #__jadmins_posts.published=1 and
    #__jadmins_categories.published=1
    ";
    $db->setQuery($sql);
    $option=$db->loadObject();
    return ($option->total+0);
  }
  function getFollowingArticlesTotalSearch($filter_search="")
  {
    $db=JFactory::getDBO();
    $sql="select 
    count(*) as total
    from #__jadmins_follow
    inner join #__jadmins_posts on #__jadmins_posts.post_id=#__jadmins_follow.post_id
    inner join #__jadmins_categories on #__jadmins_categories.cat_id=#__jadmins_posts.cat_id
    where
    #__jadmins_posts.published=1 and
    #__jadmins_categories.published=1 AND
    (#__jadmins_posts.title like '%".$db->getEscaped($filter_search)."%' OR
    #__jadmins_posts.content like '%".$db->getEscaped($filter_search)."%')
    ";
    $db->setQuery($sql);
    $option=$db->loadObject();
    return ($option->total+0);
  }
}
?>