CREATE TABLE IF NOT EXISTS `#__jadmins_categories` (
  `cat_id` int(11) DEFAULT '0',
  `title` varchar(255) DEFAULT NULL,
  `description` mediumtext,
  `published` tinyint(1) DEFAULT '1',
  UNIQUE KEY `idx_cat` (`cat_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__jadmins_follow` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `post_id` int(11) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `idx_post` (`post_id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__jadmins_posts` (
  `post_id` int(11) DEFAULT '0',
  `cat_id` int(11) DEFAULT '0',
  `joomla` varchar(255) DEFAULT NULL,
  `component` varchar(255) DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `content` text,
  `author` varchar(255) DEFAULT NULL,
  `site` varchar(255) DEFAULT NULL,
  `has_update` tinyint(1) DEFAULT '1',
  `mdate` datetime DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) DEFAULT '1',
  `reported` tinyint(1) DEFAULT '0',
  UNIQUE KEY `idx_post` (`post_id`) USING BTREE,
  KEY `idx_cat` (`cat_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__jadmins_reply` (
  `post_id` int(11) DEFAULT '0',
  `reply_id` int(11) DEFAULT '0',
  `reply` text,
  `author` varchar(255) DEFAULT NULL,
  `site` varchar(255) DEFAULT NULL,
  `mdate` datetime DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) DEFAULT '1',
  `reported` tinyint(1) DEFAULT '0',
  UNIQUE KEY `idx_reply` (`reply_id`) USING BTREE,
  KEY `idx_post` (`post_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__jadmins_sys` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `refresh_sys` int(11) DEFAULT '0',
  `refresh_follow` int(11) DEFAULT '0',
  `author_max` int(11) DEFAULT '255',
  `joomla_max` int(11) DEFAULT '255',
  `component_max` int(11) DEFAULT '255',
  `title_max` int(11) DEFAULT '255',
  `post_max` int(11) DEFAULT '3000',
  `reply_max` int(11) DEFAULT '1000',
  `post_min` int(11) DEFAULT '50',
  `intro_max` int(11) DEFAULT '200',
  `request_timeout` tinyint(3) DEFAULT '5',
  `comp_tos` varchar(255) DEFAULT NULL,
  `latest_version` varchar(255) DEFAULT '1.0.0',
  `refresh_follow_interval` int(11) DEFAULT '60',
  `lines_nr` int(11) DEFAULT '10',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

insert into #__jadmins_sys (`id`,`refresh_sys`,`refresh_follow`) values (1,0,0);