<?php
/**
 * @version     1.0.0
 * @package     com_jadmins
 * @copyright   Copyright (C) 2014. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Jadmins <mail@jadmins.com> - http://www.jadmins.com/
 */

// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.view');

/**
 * View class for a list of Jadmins.
 */
class JadminsViewFollows extends JView
{
	protected $items;
	protected $pagination;
	protected $state;
  protected $total_on_page;//number of published posts on page
  
	/**
	 * Display the view
	 */
	public function display($tpl = null)
	{
		$this->state		= $this->get('State');
		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			throw new Exception(implode("\n", $errors));
		}
    $input = JFactory::getApplication()->input;
    
    $jadmin=new jadmin();
    $this->ja_config=$jadmin->config;
    $jadmin->checkDomainName();
    
    $page=isset($_GET['page'])?$_GET['page']+0:0;
    $action=isset($_POST['action'])?$_POST['action']:"";
    $filter_search=isset($_GET['filter_search'])?trim($_GET['filter_search']):"";
    
    if($action=='unfollow')
    {
      $unfollow_post_id=isset($_POST['unfollow_post_id'])?$_POST['unfollow_post_id']+0:0;
      $jadmin->unfollowById($unfollow_post_id);
    }
    
    if($filter_search!="")
    {
      $filter_search=htmlspecialchars($filter_search);
      $following=$jadmin->getFollowingArticlesUpdatesBySearch($page,$filter_search);
      $this->items=$following;
      $pagination=new stdClass;
      $pagination->id="pag";
      $pagination->page=$page+1;
      $pagination->total=$jadmin->getFollowingArticlesTotalSearch($filter_search);
      $this->pagination=$pagination;
      $filter_search=urlencode($filter_search);
      $this->pagination_html=$jadmin->createPaginationHTML(0,$this->pagination,20,"follows&filter_search=".str_replace('"',"\\\"",$filter_search));
    }
    else
    {
      $following=$jadmin->getFollowingArticlesUpdates($page);
      $this->items=$following;
      $pagination=new stdClass;
      $pagination->id="pag";
      $pagination->page=$page+1;
      $pagination->total=$jadmin->getFollowingArticlesTotal();
      $this->pagination=$pagination;
      $this->pagination_html=$jadmin->createPaginationHTML(0,$this->pagination,20,"follows");
    }
    $this->addToolbar();
    $view = $input->getCmd('view', '');
    JadminsHelper::addSubmenu($view);
        
		parent::display($tpl);
	}

	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addToolbar()
	{
		require_once JPATH_COMPONENT.'/helpers/jadmins.php';

		$state	= $this->get('State');
		$canDo	= JadminsHelper::getActions($state->get('filter.category_id'));

		JToolBarHelper::title('Following Jadmins', 'follows.png');

/*
        //Check if the form exists before showing the add/edit buttons
        $formPath = JPATH_COMPONENT_ADMINISTRATOR.'/views/follow';
        if (file_exists($formPath)) {

            if ($canDo->get('core.create')) {
			    JToolBarHelper::addNew('follow.add','JTOOLBAR_NEW');
		    }

		    if ($canDo->get('core.edit') && isset($this->items[0])) {
			    JToolBarHelper::editList('follow.edit','JTOOLBAR_EDIT');
		    }

        }

		if ($canDo->get('core.edit.state')) {

            if (isset($this->items[0]->state)) {
			    JToolBarHelper::divider();
			    JToolBarHelper::custom('follows.publish', 'publish.png', 'publish_f2.png','JTOOLBAR_PUBLISH', true);
			    JToolBarHelper::custom('follows.unpublish', 'unpublish.png', 'unpublish_f2.png', 'JTOOLBAR_UNPUBLISH', true);
            } else if (isset($this->items[0])) {
                //If this component does not use state then show a direct delete button as we can not trash
                JToolBarHelper::deleteList('', 'follows.delete','JTOOLBAR_DELETE');
            }

            if (isset($this->items[0]->state)) {
			    JToolBarHelper::divider();
			    JToolBarHelper::archiveList('follows.archive','JTOOLBAR_ARCHIVE');
            }
            if (isset($this->items[0]->checked_out)) {
            	JToolBarHelper::custom('follows.checkin', 'checkin.png', 'checkin_f2.png', 'JTOOLBAR_CHECKIN', true);
            }
		}
        
        //Show trash and delete for components that uses the state field
        if (isset($this->items[0]->state)) {
		    if ($state->get('filter.state') == -2 && $canDo->get('core.delete')) {
			    JToolBarHelper::deleteList('', 'follows.delete','JTOOLBAR_EMPTY_TRASH');
			    JToolBarHelper::divider();
		    } else if ($canDo->get('core.edit.state')) {
			    JToolBarHelper::trash('follows.trash','JTOOLBAR_TRASH');
			    JToolBarHelper::divider();
		    }
        }
*/
		if ($canDo->get('core.admin')) {
			JToolBarHelper::preferences('com_jadmins');
		}


	}
}
