<?php
/**
 * @version     1.0.0
 * @package     com_jadmins
 * @copyright   Copyright (C) 2014. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Jadmins <mail@jadmins.com> - http://www.jadmins.com/
 */

// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.view');

/**
 * View class for a list of Jadmins.
 */
class JadminsViewPosts extends JView
{
	protected $items;
	protected $pagination;
	protected $state;
  protected $post_title;
  protected $ja_config;
  protected $post;
  protected $total_on_page;
  protected $pagination_html;
	/**
	 * Display the view
	 */
	public function display($tpl = null)
	{
		$this->state		= $this->get('State');
		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			throw new Exception(implode("\n", $errors));
		}
    $input = JFactory::getApplication()->input;
    
    $post_id=isset($_GET['id'])?$_GET['id']+0:0;
    
    $jadmin=new jadmin();
    $this->ja_config=$jadmin->config;
    $jadmin->checkDomainName();
    $action=isset($_POST['action'])?$_POST['action']:"";
    
    if($action=="report")
    {
      $jadmin->reportPost();
    }
    if($action=="report_reply")
    {
      $report_reply_id=isset($_POST['report_reply_id'])?$_POST['report_reply_id']:"";
      $jadmin->reportReply($report_reply_id);
    }
    if($action=="submit_reply")
    {
      $jadmin->submitNewReply();
    }
    
    $page=isset($_GET['page'])?$_GET['page']+0:0;
    $categ=isset($_GET['categ'])?$_GET['categ']+0:0;
    
    $this->post=$jadmin->getArticle($post_id);
    
    $updates=$jadmin->getArticleReplyUpdates($page,$post_id);//get from jadmins.com
    //$updates=array();//test jadmins.com offline
    if(isset($updates['pagination']))
    {
      $this->pagination=$updates['pagination'];
    }
    if(isset($this->pagination->page))
    {
      $this->pagination->page++;
    }
    if(isset($updates['items']) && count($updates['items'])>0)
    {
      $this->items=$updates['items'];
    }
    else//get records from local
    {
      /**/
      $this->items=$jadmin->getArticleReply($page,$post_id);
      //$this->items=array();//test no records on local
      $pagination=new stdClass;
      $pagination->id="pag";
      $pagination->page=$page;
      $pagination->total=$jadmin->getArticleReplyNr($post_id);
      $this->pagination=$pagination;
      if(isset($this->pagination->page))
      {
        $this->pagination->page++;
      }
      
    }
    
    if(isset($this->post->title))
    {
      $this->post_title=$this->post->title;
    }
    else
    {
      $this->post_title=JText::_('COM_JADMINS_TITLE_POSTS');
    }

    $this->total_on_page=count($this->items);
    $this->pagination_html=$jadmin->createPaginationHTML($categ,$this->pagination,$this->total_on_page,"posts&id=".$post_id);
    
    $this->addToolbar();
    $view = $input->getCmd('view', '');
    JadminsHelper::addSubmenu($view);
        
		parent::display($tpl);
	}

	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addToolbar()
	{
		require_once JPATH_COMPONENT.'/helpers/jadmins.php';

		$state	= $this->get('State');
		$canDo	= JadminsHelper::getActions($state->get('filter.category_id'));

		JToolBarHelper::title($this->post_title, 'posts.png');
    
    /*
        //Check if the form exists before showing the add/edit buttons
        $formPath = JPATH_COMPONENT_ADMINISTRATOR.'/views/post';
        if (file_exists($formPath)) {

            if ($canDo->get('core.create')) {
			    JToolBarHelper::addNew('post.add','JTOOLBAR_NEW');
		    }

		    if ($canDo->get('core.edit') && isset($this->items[0])) {
			    JToolBarHelper::editList('post.edit','JTOOLBAR_EDIT');
		    }

        }

		if ($canDo->get('core.edit.state')) {

            if (isset($this->items[0]->state)) {
			    JToolBarHelper::divider();
			    JToolBarHelper::custom('posts.publish', 'publish.png', 'publish_f2.png','JTOOLBAR_PUBLISH', true);
			    JToolBarHelper::custom('posts.unpublish', 'unpublish.png', 'unpublish_f2.png', 'JTOOLBAR_UNPUBLISH', true);
            } else if (isset($this->items[0])) {
                //If this component does not use state then show a direct delete button as we can not trash
                JToolBarHelper::deleteList('', 'posts.delete','JTOOLBAR_DELETE');
            }

            if (isset($this->items[0]->state)) {
			    JToolBarHelper::divider();
			    JToolBarHelper::archiveList('posts.archive','JTOOLBAR_ARCHIVE');
            }
            if (isset($this->items[0]->checked_out)) {
            	JToolBarHelper::custom('posts.checkin', 'checkin.png', 'checkin_f2.png', 'JTOOLBAR_CHECKIN', true);
            }
		}
        
        //Show trash and delete for components that uses the state field
        if (isset($this->items[0]->state)) {
		    if ($state->get('filter.state') == -2 && $canDo->get('core.delete')) {
			    JToolBarHelper::deleteList('', 'posts.delete','JTOOLBAR_EMPTY_TRASH');
			    JToolBarHelper::divider();
		    } else if ($canDo->get('core.edit.state')) {
			    JToolBarHelper::trash('posts.trash','JTOOLBAR_TRASH');
			    JToolBarHelper::divider();
		    }
        }
        */
		if ($canDo->get('core.admin')) {
			JToolBarHelper::preferences('com_jadmins');
		}


	}
}
