<?php
/**
 * @version     1.0.0
 * @package     com_jadmins
 * @copyright   Copyright (C) 2014. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Jadmins <mail@jadmins.com> - http://www.jadmins.com/
 */

// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.view');

/**
 * View class for a list of Jadmins.
 */
class JadminsViewSearchs extends JView
{
	protected $items;
	protected $pagination;
	protected $state;
  protected $ja_config;
  protected $total_on_page;//number of published posts on page
  protected $pagination_html;
	/**
	 * Display the view
	 */
	public function display($tpl = null)
	{
		$this->state		= $this->get('State');
		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			throw new Exception(implode("\n", $errors));
		}
    $input = JFactory::getApplication()->input;
    
    $page=isset($_GET['page'])?$_GET['page']+0:0;
    $jadmin=new jadmin();
    $this->ja_config=$jadmin->config;
    $jadmin->checkDomainName();
    $filter_search=isset($_GET['filter_search'])?trim($_GET['filter_search']):"";
    
    $filter_ok=1;
    $tarr=explode(" ",$filter_search);
    if(count($tarr)<=1 && $filter_search!="")
    {
      $application = JFactory::getApplication();
      $application->enqueueMessage('Please search with at least 2 words','error');
      $filter_ok=0;
    }
    $maxl=0;
    foreach($tarr as $t)
    {
      if(strlen($t)>$maxl)
        $maxl=strlen($t);
    }
    if($maxl<4 && $filter_search!="")
    {
      $application = JFactory::getApplication();
      $application->enqueueMessage('At least 1 word must have at least 4 characters','error');
      $filter_ok=0;
    }
    if($filter_search!="" && $filter_ok==1)
    {
      $updates=$jadmin->getSearchArticlesUpdate($page,$filter_search);//get from jadmins.com
      //$updates=array();//test jadmins.com offline
      if(isset($updates['pagination']))
      {
        $this->pagination=$updates['pagination'];
      }
      if(isset($this->pagination->page))
      {
        $this->pagination->page++;
      }
      if(isset($updates['items']) && count($updates['items'])>0)
      {
        $this->items=$updates['items'];
      }
      else//get records from local
      {
        /**/
        $this->items=$jadmin->getSearchPosts($page,$filter_search);
        //$this->items=array();//test no records on local
        $pagination=new stdClass;
        $pagination->id="pag";
        $pagination->page=$page;
        $pagination->total=$jadmin->getSearchArticleNr($filter_search);
        $this->pagination=$pagination;
        if(isset($this->pagination->page))
        {
          $this->pagination->page++;
        }
        
      }
      $this->total_on_page=count($this->items);
      $this->pagination_html=$jadmin->createPaginationHTML(0,$this->pagination,$this->total_on_page,"searchs&filter_search=".str_replace('"',"\\\"",$filter_search));
    }
    $this->addToolbar();   
    $view = $input->getCmd('view', '');
    JadminsHelper::addSubmenu($view);
    
		parent::display($tpl);
	}

	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addToolbar()
	{
		require_once JPATH_COMPONENT.'/helpers/jadmins.php';

		$state	= $this->get('State');
		$canDo	= JadminsHelper::getActions($state->get('filter.category_id'));

		JToolBarHelper::title('Search Jadmins DB', 'searchs.png');
/*
        //Check if the form exists before showing the add/edit buttons
        $formPath = JPATH_COMPONENT_ADMINISTRATOR.'/views/search';
        if (file_exists($formPath)) {

            if ($canDo->get('core.create')) {
			    JToolBarHelper::addNew('search.add','JTOOLBAR_NEW');
		    }

		    if ($canDo->get('core.edit') && isset($this->items[0])) {
			    JToolBarHelper::editList('search.edit','JTOOLBAR_EDIT');
		    }

        }

		if ($canDo->get('core.edit.state')) {

            if (isset($this->items[0]->state)) {
			    JToolBarHelper::divider();
			    JToolBarHelper::custom('searchs.publish', 'publish.png', 'publish_f2.png','JTOOLBAR_PUBLISH', true);
			    JToolBarHelper::custom('searchs.unpublish', 'unpublish.png', 'unpublish_f2.png', 'JTOOLBAR_UNPUBLISH', true);
            } else if (isset($this->items[0])) {
                //If this component does not use state then show a direct delete button as we can not trash
                JToolBarHelper::deleteList('', 'searchs.delete','JTOOLBAR_DELETE');
            }

            if (isset($this->items[0]->state)) {
			    JToolBarHelper::divider();
			    JToolBarHelper::archiveList('searchs.archive','JTOOLBAR_ARCHIVE');
            }
            if (isset($this->items[0]->checked_out)) {
            	JToolBarHelper::custom('searchs.checkin', 'checkin.png', 'checkin_f2.png', 'JTOOLBAR_CHECKIN', true);
            }
		}
        
        //Show trash and delete for components that uses the state field
        if (isset($this->items[0]->state)) {
		    if ($state->get('filter.state') == -2 && $canDo->get('core.delete')) {
			    JToolBarHelper::deleteList('', 'searchs.delete','JTOOLBAR_EMPTY_TRASH');
			    JToolBarHelper::divider();
		    } else if ($canDo->get('core.edit.state')) {
			    JToolBarHelper::trash('searchs.trash','JTOOLBAR_TRASH');
			    JToolBarHelper::divider();
		    }
        }
*/
		if ($canDo->get('core.admin')) {
			JToolBarHelper::preferences('com_jadmins');
		}


	}
}
